#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: admacl_edit.cgi,v 1.6 2005/08/16 21:22:16 ynakam Exp $

# Display access rights for administration

use Fcntl;
use CGI qw(:standard);
do "./common.pl";

#ACL for administration
#key:the argument of allowadm
#value:1
local %Global_adm_acl;
local %adm_acl;

$Jscript =<<"EOL";
function check_changed(msg) {
    if (parent.config.document.edit_form.elements["changed"].value == 1)
    {
	alert(msg);
    }
}

function set_change() {
    parent.config.document.edit_form.elements["changed"].value = 1;
}

function unset_change() {
    parent.config.document.edit_form.elements["changed"].value = 0;
}
EOL

local $Policy_root = set_policy_root();

local $domain;
$domain = param("domain");
if ($domain eq "")
{
    &print_header();
    print "<html></html>";
    return;
}

local $all_flag;
$all_flag = check_adm($domain, $Policy_root, "all");

&read_adm_acl($domain, \%adm_acl);
if ($domain ne "global")
{
    &read_adm_acl("global", \%Global_adm_acl);
}

&print_editor();

sub print_editor() {
    &print_header();
    my $notchange = $text{"notchanged"};
    print start_html(-title=>$text{"admin_acl"},-onUnload=>"check_changed(\'$notchange\')");
    print "<SCRIPT language=\"Javascript\">";
    print $Jscript;
    print "</SCRIPT>";

    print h2(&text("adm_title", $domain)), p;

    my $enctype =&CGI::URL_ENCODED;
    print get_form_str("setadmacl.cgi","edit_form",$enctype);
    print hidden(-name=>"domain",-value=>"$domain");
    print hidden(-name=>"changed",-value=>"0");


#  foreach (keys %adm_acl){
#   print "$_".";"."$adm_acl{$_}",p;
# }
    my $opt;
    my $row;
    my @table;

    $row=[$text{"kernel_adm_menu"}];
    push @table,th({-bgcolor=>"yellow"},$row);
    foreach $opt(@ALLOWKERNEL_LIST){
	$row = print_check_box($opt,$text{"adm_$opt"});
	push @table,td([$row]);
    }
    $row=[$text{"seop_adm_menu"}];
    push @table,th({-bgcolor=>"yellow"},$row);
    foreach $opt(@ALLOWSEOP_LIST){
	$row = print_check_box($opt,$text{"adm_$opt"});
	push @table,td([$row]);
	
    }  
    $row=[$text{"priv_adm_menu"}];
    push @table,th({-bgcolor=>"yellow"},$row);
    foreach $opt(@ALLOWPRIV_LIST){
	$row = print_check_box($opt,$text{"adm_$opt"});
	push @table,td([$row]);
    }
    print table(Tr(\@table));    

    print submit(-value=>$text{"apply"},-onClick=>"unset_change()");
    print end_form();
    print end_html();
}

sub print_check_box($$) {
    my $name;
    my $label;
    my $table_ref;
    my $checkstr;
    ($name,$label,$table_ref) = @_;

    if ($Global_adm_acl{$name} == 1||($all_flag == 1 && $name ne "all") ){
	$checkstr = $text{"ok"}."$label",p;
    }else{
	my $checked;
	$checked = $adm_acl{$name};
	$checkstr = checkbox(-name=>$name,-value=>"on",-label=>$label,-checked=>$checked,-onChange=>"set_change()"),p;
    }
    return $checkstr;
}


sub read_adm_acl() {
    my $domain;
    my $hash_ref;
    my $filename;

    ($domain,$hash_ref) = @_;

    $filename = get_policy_file_name($domain, $Policy_root);

    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>){
	# Skip spaces in the head of line 
	if (/[^\s\t]+.+/){
	    $_ = $&;
	}
	if (/^allowkernel[\s\t]/||/^allowseop[\s\t]/||/^allowpriv[\s\t]/){
	    my @tmp;
	    @tmp = split(/[\s\t]+/,$_);
	    my $str;
	    $str = $tmp[1];
	    if ($str =~ /;/){
		chop($str);
	    }
	    my @perms;
	    @perms = split(/,/, $str);
	    foreach (@perms){
		$$hash_ref{$_} = 1;
	    }
	}
    }
   

    close(FILE);
}
