#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: procacl_edit.cgi,v 1.3 2005/08/16 21:22:16 ynakam Exp $

#configuration of proc filesystem.
use Fcntl;
use CGI qw(:standard);
require "common.pl";

$Jscript =<<"EOL";
function check_changed(msg) {
    if (parent.config.document.edit_form.elements["changed"].value ==1)
    {
	alert(msg);
    }
}

function set_change()
{
    parent.config.document.edit_form.elements["changed"].value=1;
}

function unset_change() {
    parent.config.document.edit_form.elements["changed"].value=0;
}
EOL

#information of "allowproc" is stored.
#key:option of "allowproc". ex:-self
#value:"r"or"w",separated by space
local %proc_acl;
local %Global_proc_acl;


local $Policy_root=set_policy_root();

local $domain;
$domain=param("domain");
if ($domain eq "")
{
    &print_header();
    print "<html> </html>";

  return;
}

local $all_flag;
$all_flag = check_adm($domain, $Policy_root, "all");


&read_proc_acl($domain,\%proc_acl);
if ($domain ne "global")
{
    &read_proc_acl("global",\%Global_proc_acl);
}

&print_table();

sub read_proc_acl($$) {
    my $domain;
    my $hash_ref;
    my $filename;

    ($domain,$hash_ref)=@_;

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	#skip space in the head of line
	if (/[^\s\t]+.+/)
	{
	    $_=$&;
	}

	if (/^allowproc[\s\t]/)
	{
	    my @tmp;
	    my $opt;
	    my $perm;
	    @tmp= split(/[\s\t]+/,$_);
	    $opt=$tmp[1];
	    $perm=$tmp[2];
	    if ($perm=~/;/)
	    {
		chop($perm);
	    }
	    my @tmp2;
	    @tmp2=split(/,/,$perm);

	    $$hash_ref{$opt}.=" "."@tmp2";
	}
    }

  close(FILE);
}

sub print_table() {
    &print_header();

    my $notchange=$text{"notchanged"};
    print start_html(-title=>$text{"proc_acl"},-onUnload=>"check_changed(\'$notchange\')");
    print "<SCRIPT language=\"Javascript\">";
    print $Jscript;
    print "</SCRIPT>";

    print h2(&text("proc_acl_title",$domain));

    print start_form(-method=>"post",-action=>"setprocacl.cgi",-name=>"edit_form");
    print hidden(-name=>"domain",-value=>"$domain");
    print hidden(-name=>"changed",-value=>"0");

    my @table;
    push @table,td(["","read","write"]);

    &make_field("-self",$text{"proc_self"},\@table);
    &make_field("-other",$text{"proc_other"},\@table);

    push @table,td([submit(-value=>$text{"apply"},-onClick=>"unset_change()")]);

    print table(Tr(\@table));
    print end_form(),end_html();
}

#construct row
sub make_field($$$) {
    my $key;
    my $menustr;
    my $table_ref;
    ($key,$menustr,$table_ref)=@_;

    my $check1str;
    if ($Global_proc_acl{$key}=~/r/ || $all_flag == 1)
    {
	$check1str=$text{"ok"};
    }
    else
    {
	my $checked=0;
	if ($proc_acl{$key}=~/r/)
	{
	    $checked=1;
	}
	$check1str=checkbox(-name=>"$key"."_r",-label=>"",-value=>"on",-checked=>"$checked",-onChange=>"set_change()");
  }

    my $check2str;
    if ($Global_proc_acl{$key}=~/w/ || $all_flag == 1)
    {
	$check2str=$text{"ok"};
    }
    else
    {
	my $checked=0;
	if ($proc_acl{$key}=~/w/)
	{
	    $checked=1;
	}
	$check2str=checkbox(-name=>"$key"."_w",-label=>"",-value=>"on",-checked=>"$checked",-onchange=>"set_change()");
    }

    push @$table_ref,td(["$menustr",$check1str,$check2str]);
}
