#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: setadmacl.cgi,v 1.6 2005/08/16 21:22:16 ynakam Exp $

#save allowadm
use Fcntl;
use CGI qw(:standard);
require "common.pl";


#ACL for administration
#key:the argument of allowadm
#value:1
local %adm_acl;
local @buffer;

local $domain=param("domain");
local $Policy_root=set_policy_root();

foreach (@ALLOWKERNEL_LIST){
    &set_acl("$_");
}
foreach (@ALLOWSEOP_LIST){
    &set_acl("$_");
}
foreach (@ALLOWPRIV_LIST){
    &set_acl("$_");
}

if ($adm_acl{"relabel"} == 1){
    $adm_acl{"getsecurity"}=1;
    $adm_acl{"search"}=1;   
}

if ($adm_acl{"klog_write"} == 1){
    $adm_acl{"netlink"}=1;
}



my @skip;
push @skip,"^allowkernel[\\s\\t]";
push @skip,"^allowseop[\\s\\t]";
push @skip,"^allowpriv[\\s\\t]";

&read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);

&write_config($domain);

redirect("admacl_edit.cgi?domain=$domain");

sub set_acl($) {
    my $name;
    $name=$_[0];

    if (param($name) eq "on")
    {
	$adm_acl{$name}=1;
    }
}

sub write_config($) {
    my $domain;
    my $filename;
    $domain=$_[0];

    $filename = get_policy_file_name($domain, $Policy_root);
    
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    print FILE "{\n";

    foreach (@buffer)  {
	print FILE "$_\n";
    }

    my $key;
    foreach $key (@ALLOWKERNEL_LIST){
	if($adm_acl{$key}==1){
	    print FILE "allowkernel $key;\n";
	}	
    }
    foreach $key (@ALLOWSEOP_LIST){
	if($adm_acl{$key}==1){
	    print FILE "allowseop $key;\n";
	}
    }
    foreach $key (@ALLOWPRIV_LIST){
	if($adm_acl{$key}==1){
	    print FILE "allowpriv $key;\n";
	}
    }
      

    print FILE "}\n";
    close(FILE);
}
