#!/usr/bin/perl
# By Yuichi Nakamura <ynakam@gwu.edu>
# Used code from setprocacl.cgi

#save ACL of fs
use Fcntl;
use CGI qw(:standard);
require "common.pl";

#information of "allowfs" is stored.
#key:filesystem
#value:s|r|x|w separated by space
local %fs_acl;
#Information about allowfs tmpfs exclusive.
#key domain name
#value: r|w|s|x separated by space
local %tmpfs_acl;
#1,if domain can create file in tmpfs.
local $tmpfs_create_flag;

local @buffer;

local $domain=param("domain");
local $Policy_root=set_policy_root();
local @supported_fs =@SUPPORTED_FS;

#print CGI::header(-type=>'text/html',-charset=>'EUC_JP');
my $fs;
foreach $fs (@supported_fs){
    &set_acl($fs);
}

&set_tmpfs_acl();


my @skip;
#push @skip,"^allowfs[\\s\\t]+\\S+[\\s\\t]+[\\w,^;]+[\\s\\t]*;";
push @skip,"^allowfs[\\s\\t]+";
&read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);
&write_conf_file($domain);

redirect("fsacl_edit.cgi?domain=$domain");

sub set_acl($) {
    my $name;
    $name=$_[0];

    if (param($name."_r") eq "on"){
	$fs_acl{$name}.="r,";
    }
    if (param($name."_w") eq "on"){
	$fs_acl{$name}.="w,";
    }
     if (param($name."_s") eq "on"){
	$fs_acl{$name}.="s,";
    }
    if (param($name."_x") eq "on"){
	$fs_acl{$name}.="x,";
    }
}

sub set_tmpfs_acl(){
    my @keys = param();
    my $key;
    foreach $key (@keys){
	if($key eq "tmpfsexc_create"){
	    $tmpfs_create_flag = 1;
	    next;
	}
	if($key=~/tmpfsexc/){
	    my @tmp;
	    my $d;
	    my $perm;
	    @tmp = split(/\//,$key);
	    $d=$tmp[1];
	    $perm = $tmp[2];
	    $tmpfs_acl{$d}.="$perm,";
	}
    }
}



sub write_conf_file($) {
    my $domain;
    my $filename;
    $domain=$_[0];

    $filename = get_policy_file_name($domain, $Policy_root);    
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    print FILE "{\n";
    foreach (@buffer){
	print FILE "$_\n";
    }

    my $key;
    foreach $key (keys %fs_acl){
	chop($fs_acl{$key});#chop ","
	print FILE "allowfs $key $fs_acl{$key};\n";
    }
    if($tmpfs_create_flag == 1){
	my $prefix = $domain;
	chop($prefix);#chop _t
	chop($prefix);
	print FILE "allowfs tmpfs exclusive $prefix"."_tmpfs_t;\n";
    }
    
    foreach $key (keys %tmpfs_acl){
	chop($tmpfs_acl{$key}); #chop ","
	if($key eq "-all"){
	    print FILE "allowfs tmpfs exclusive -all $tmpfs_acl{$key};\n";
	}else{
	    my $prefix = $key;
	    chop($prefix);  #chop _t
	    chop($prefix);
	    print FILE "allowfs tmpfs $prefix"."_tmpfs_t $tmpfs_acl{$key};\n";
	}
    } 
    
    print FILE "}\n";
    
    close(FILE);
}
